<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://themeforest.net/user/nouthemes/portfolio
 * @since      1.0.0
 *
 * @package    Leopard_Wordpress_Offload_Media
 * @subpackage Leopard_Wordpress_Offload_Media/admin/partials
 */
$tab = 'connectS3';
if(isset($_GET['tab'])){
	$tab = $_GET['tab'];
}
$remove_file_server = get_option('nou_leopard_offload_media_remove_from_server_checkbox');
$action_scan = get_option('nou_leopard_offload_media_action');
$step_scan = get_option('nou_leopard_offload_media_step_scan_attachments', 0);
?>	
<div class="notice-info notice">
	<p><a class="button-primary" target="_blank" href="<?php echo esc_url('//nouthemes.com/docs/leopard/');?>"><?php esc_html_e('Read the Leopard features!', 'leopard-wordpress-offload-media');?></a></p>
</div>

<div class="wrap" id="leopard-wordpress-offload-media-wrap">
	<h1><?php esc_html_e( 'Leopard Offload Media', 'leopard-wordpress-offload-media' );?></h1>
	
	<?php Leopard_Wordpress_Offload_Media_Messages::show_messages();?>

	<div class="nou_leopard_wom_loading"><?php esc_html_e('Loading', 'leopard-wordpress-offload-media');?>&#8230;</div>

	<div class="col-left">
		<h2 class="nav-tab-wrapper">
		    <a class="nav-tab <?php if($tab == 'connectS3'){echo 'nav-tab-active';}?>" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=connectS3'));?>"><?php esc_html_e('Storage Settings', 'leopard-wordpress-offload-media');?></a>
		    <?php $status = get_option('nou_leopard_offload_media_connection_success', 0);?>
		    <?php if($status == 1):?>

		    	<?php $bucket_selected = get_option('nou_leopard_offload_media_connection_bucket_selected_select', '');?>
			    <a class="<?php if(empty($bucket_selected)){echo 'red';}?> nav-tab <?php if($tab == 'generalsettings'){echo 'nav-tab-active';}?>" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=generalsettings'));?>">
			    	<?php esc_html_e('Bucket Settings', 'leopard-wordpress-offload-media');?>
			    	<?php 
			    	if(empty($bucket_selected)){
			    		esc_html_e('(Bucket does not exist)', 'leopard-wordpress-offload-media');
			    	}
			    	?>	
			    </a>
			    <a class="nav-tab <?php if($tab == 'assets'){echo 'nav-tab-active';}?>" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=assets'));?>"><?php esc_html_e('Assets', 'leopard-wordpress-offload-media');?></a>          
			    <a class="nav-tab <?php if($tab == 'RewriteUrl'){echo 'nav-tab-active';}?>" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=RewriteUrl'));?>"><?php esc_html_e('URL Rewriting', 'leopard-wordpress-offload-media');?></a>          
			    <a class="nav-tab <?php if($tab == 'cors'){echo 'nav-tab-active';}?>" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=cors'));?>"><?php esc_html_e('CORS', 'leopard-wordpress-offload-media');?></a>         
			    <a class="nav-tab <?php if($tab == 'advanced'){echo 'nav-tab-active';}?>" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=advanced'));?>"><?php esc_html_e('Advanced', 'leopard-wordpress-offload-media');?></a>
			    <a class="nav-tab <?php if($tab == 'sync'){echo 'nav-tab-active';}?>" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=sync'));?>"><?php esc_html_e('Sync Data', 'leopard-wordpress-offload-media');?></a>
			<?php endif;?>     

			<?php if($status == 1):?>
				<a class="nav-tab export-settings" href="<?php echo esc_url(admin_url('admin.php?page=leopard_offload_media&tab=import'));?>"><?php esc_html_e('Import/Export settings', 'leopard-wordpress-offload-media');?></a>     
			<?php endif;?> 
		</h2>
		<form method="post">
			<input type="hidden" id="nou_leopard_wom_settings_nonce" name="nou_leopard_wom_settings_nonce" value="<?php echo esc_attr(wp_create_nonce('nou_leopard_wom_settings_nonce'));?>">
			
			<?php 
			if($tab == 'connectS3'){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-connect.php';
			}

			if($tab == 'generalsettings' && $status == 1){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-general.php';
			}

			if($tab == 'RewriteUrl' && $status == 1){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-url.php';
			}

			if($tab == 'assets' && $status == 1){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-assets.php';
			}

			if($tab == 'cors' && $status == 1){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-cors.php';
			}

			if($tab == 'advanced' && $status == 1){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-advanced.php';
			}

			if($tab == 'import' && $status == 1){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-import.php';
			}

			if($tab == 'sync' && $status == 1){
				require_once plugin_dir_path( dirname( __FILE__ ) ) . 'partials/leopard-wordpress-offload-media-admin-settings-sync.php';
			}else{
			?>
			<input data-tab="<?php echo esc_attr($tab);?>" type="submit" id="nou_leopard_wom_settings_submit" class="button-primary" value="<?php esc_html_e('Save Changes', 'leopard-wordpress-offload-media');?>">
			<?php }?>

		</form>
	</div>
	<div class="col-right">
		<?php 
		if(!nou_leopard_offload_media_cache_folder_check()):
		?>
		<div class="card error">
			<h2 class="title">
				<?php esc_html_e('System error!', 'leopard-wordpress-offload-media');?>
			</h2>
			<p><?php printf( _x( 'Please make sure %s is a writable directory.', 'writable directory', 'leopard-wordpress-offload-media' ), LEOPARD_WORDPRESS_OFFLOAD_MEDIA_CACHE_PATH );?></p>
		</div>
		<?php endif;?>
		
		<?php if($status == 1):?>

			<div class="card schedule">
				<h2 class="title">
					<?php esc_html_e('Timed a scheduled task to run in the background.', 'leopard-wordpress-offload-media');?>
					<?php esc_html_e('Current time: ', 'leopard-wordpress-offload-media');?>
					<?php 
					$dt = leopard_wordpress_offload_media_datetime();
					echo esc_html( $dt->format("H:i") );
					?>
				</h2>
				<form method="post">
					<input type="hidden" id="nou_leopard_wom_settings_nonce_scheduled" name="nou_leopard_wom_settings_nonce" value="<?php echo esc_attr(wp_create_nonce('nou_leopard_wom_settings_nonce'));?>">
					<?php esc_html_e('From', 'leopard-wordpress-offload-media');?>
					<select name="nou_leopard_wom_cronjob_timed_from">
						<option value="24" <?php selected( get_option('nou_leopard_wom_cronjob_timed_from', 24), 24 ); ?>><?php esc_html_e('Default', 'leopard-wordpress-offload-media');?></option>
						<?php 
						foreach(range(0, 23) as $h){
							echo '<option value="'. esc_attr($h) .'" '.selected( get_option('nou_leopard_wom_cronjob_timed_from', 24), $h, false ).'>'. esc_attr($h) .':00</option>';
						}	
						?>
					</select>
					<?php esc_html_e('To', 'leopard-wordpress-offload-media');?>
					<select name="nou_leopard_wom_cronjob_timed_to">
						<option value="24" <?php selected( get_option('nou_leopard_wom_cronjob_timed_to', 24), 24 ); ?>><?php esc_html_e('Default', 'leopard-wordpress-offload-media');?></option>
						<?php 
						foreach(range(0, 23) as $h){
							echo '<option value="'. esc_attr($h) .'" '.selected( get_option('nou_leopard_wom_cronjob_timed_to', 24), $h, false ).'>'. esc_attr($h) .':00</option>';
						}	
						?>
					</select>
					<button type="submit" class="button-secondary"><?php esc_html_e('Save', 'leopard-wordpress-offload-media');?></button>
				</form>
			</div>

			<?php if(empty($action_scan) || $action_scan == 'download_files_from_bucket'):?>
				<div class="card action_download_files_from_bucket">
					<?php if( ($action_scan == 'download_files_from_bucket') && ($step_scan == 1 || $step_scan == 2) ):?>
						<?php if($step_scan == 2):?>
							<h2 class="title"><?php esc_html_e('Step 2: Download all files from bucket to server.', 'leopard-wordpress-offload-media');?></h2>
						<?php else:?>
							<h2 class="title"><?php esc_html_e('Step 1: Scan attachments on your media library.', 'leopard-wordpress-offload-media');?></h2>
						<?php endif;?>

						<div class="copy-process step-<?php echo esc_attr($step_scan);?>">
							<div class="iziToastloading spin_loading"></div>
							<div class="progress-bar">
								<span id="percent" style="line-height: 15px;height: 15px;">0%</span>
								<span class="bar" style="height: 15px;"><span class="progress"></span></span>
							</div>
							<div class="current-sync-process progress_count"></div>
							<div class="output hidden"></div>
						</div>
						<button type="button" class="button-secondary" id="nou_leopard_wom_settings_copy_files_to_bucket_kill"><?php esc_html_e('Kill process.', 'leopard-wordpress-offload-media');?></button>

					<?php else: ?>
						<h2 class="title"><?php esc_html_e('Download all files from bucket to server.', 'leopard-wordpress-offload-media');?></h2>
						<button type="button" class="button-secondary" id="nou_leopard_wom_settings_download_files_from_bucket"><?php esc_html_e('Download files', 'leopard-wordpress-offload-media');?></button>
					<?php endif;?>
				</div>
			<?php endif;?>
			
			<?php if(empty($action_scan) || $action_scan == 'remove_files_from_bucket'):?>
				<div class="card action_remove_files_from_bucket">
					<?php if( ($action_scan == 'remove_files_from_bucket') && ($step_scan == 1 || $step_scan == 2) ):?>
						<?php if($step_scan == 2):?>
							<h2 class="title"><?php esc_html_e('Step 2: Remove all files from bucket.', 'leopard-wordpress-offload-media');?></h2>
						<?php else:?>
							<h2 class="title"><?php esc_html_e('Step 1: Scan attachments on your media library.', 'leopard-wordpress-offload-media');?></h2>
						<?php endif;?>

						<div class="copy-process step-<?php echo esc_attr($step_scan);?>">
							<div class="iziToastloading spin_loading"></div>
							<div class="progress-bar">
								<span id="percent" style="line-height: 15px;height: 15px;">0%</span>
								<span class="bar" style="height: 15px;"><span class="progress"></span></span>
							</div>
							<div class="current-sync-process progress_count"></div>
							<div class="output hidden"></div>
						</div>
						<button type="button" class="button-secondary" id="nou_leopard_wom_settings_copy_files_to_bucket_kill"><?php esc_html_e('Kill process.', 'leopard-wordpress-offload-media');?></button>

					<?php else: ?>
						<h2 class="title"><?php esc_html_e('Remove all files from bucket.', 'leopard-wordpress-offload-media');?></h2>
						<button type="button" class="button-secondary" id="nou_leopard_wom_settings_remove_files_from_bucket"><?php esc_html_e('Remove files', 'leopard-wordpress-offload-media');?></button>
					<?php endif;?>
				</div>
			<?php endif;?>

			<?php if(empty($action_scan) || $action_scan == 'remove_files_from_server'):?>
				<?php if($remove_file_server):?>
					<div class="card action_remove_files_from_server">
						<?php if( ($action_scan == 'remove_files_from_server') && ($step_scan == 1 || $step_scan == 2) ):?>
							<?php if($step_scan == 2):?>
								<h2 class="title"><?php esc_html_e('Step 2: Remove all files from server.', 'leopard-wordpress-offload-media');?></h2>
							<?php else:?>
								<h2 class="title"><?php esc_html_e('Step 1: Scan attachments on your media library.', 'leopard-wordpress-offload-media');?></h2>
							<?php endif;?>

							<div class="copy-process step-<?php echo esc_attr($step_scan);?>">
								<div class="iziToastloading spin_loading"></div>
								<div class="progress-bar">
									<span id="percent" style="line-height: 15px;height: 15px;">0%</span>
									<span class="bar" style="height: 15px;"><span class="progress"></span></span>
								</div>
								<div class="current-sync-process progress_count"></div>
								<div class="output hidden"></div>
							</div>
							<button type="button" class="button-secondary" id="nou_leopard_wom_settings_copy_files_to_bucket_kill"><?php esc_html_e('Kill process.', 'leopard-wordpress-offload-media');?></button>

						<?php else: ?>
							<h2 class="title"><?php esc_html_e('Remove all files from server.', 'leopard-wordpress-offload-media');?></h2>
							<button type="button" class="button-secondary" id="nou_leopard_wom_settings_remove_files_from_server"><?php esc_html_e('Remove files', 'leopard-wordpress-offload-media');?></button>
						<?php endif;?>
					</div>
				<?php endif;?>
			<?php endif;?>

			<?php if(empty($action_scan) || $action_scan == 'copy_files_to_bucket'):?>
				<div id="copy_files_to_bucket_card" class="card action_copy_files_to_bucket">
					<?php if( ($action_scan == 'copy_files_to_bucket') && ($step_scan == 1 || $step_scan == 2) ):?>
						<?php if($step_scan == 2):?>
							<h2 class="title"><?php esc_html_e('Step 2: Offloading media library items to bucket.', 'leopard-wordpress-offload-media');?></h2>
						<?php else:?>
							<h2 class="title"><?php esc_html_e('Step 1: Scan attachments on your media library.', 'leopard-wordpress-offload-media');?></h2>
						<?php endif;?>

						<div class="copy-process step-<?php echo esc_attr($step_scan);?>">
							<div class="iziToastloading spin_loading"></div>
							<div class="progress-bar">
								<span id="percent" style="line-height: 15px;height: 15px;">0%</span>
								<span class="bar" style="height: 15px;"><span class="progress"></span></span>
							</div>
							<div class="current-sync-process progress_count"></div>
							<div class="output hidden"></div>
						</div>
						<button type="button" class="button-secondary" id="nou_leopard_wom_settings_copy_files_to_bucket_kill"><?php esc_html_e('Kill process.', 'leopard-wordpress-offload-media');?></button>

					<?php else: ?>
						<h2 class="title"><?php esc_html_e('Copy all files from server to bucket.', 'leopard-wordpress-offload-media');?></h2>
						<button type="button" class="button-secondary" id="nou_leopard_wom_settings_copy_files_to_bucket"><?php esc_html_e('Copy files', 'leopard-wordpress-offload-media');?></button>
					<?php endif;?>
				</div>
			<?php endif;?>

		<?php endif;?>
	</div>
</div>
<!-- This file should primarily consist of HTML with a little bit of PHP. -->
